from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PkgRoutesWebhooksFinchWebhookData")


@_attrs_define
class PkgRoutesWebhooksFinchWebhookData:
    """
    Attributes:
        autentication_method (str | Unset): credential, api_token, oauth, assisted,
        status (str | Unset): pending, processing, connected, reauth, error_permissions, error_no_account_setup,
            disconnected
    """

    autentication_method: str | Unset = UNSET
    status: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        autentication_method = self.autentication_method

        status = self.status

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if autentication_method is not UNSET:
            field_dict["autentication_method"] = autentication_method
        if status is not UNSET:
            field_dict["status"] = status

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        autentication_method = d.pop("autentication_method", UNSET)

        status = d.pop("status", UNSET)

        pkg_routes_webhooks_finch_webhook_data = cls(
            autentication_method=autentication_method,
            status=status,
        )

        pkg_routes_webhooks_finch_webhook_data.additional_properties = d
        return pkg_routes_webhooks_finch_webhook_data

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
